diff -uNr trunk-r680/encoder/slicetype.c trunk/encoder/slicetype.c
--- trunk-r680/encoder/slicetype.c	2007-07-17 11:11:18.000000000 +0400
+++ trunk/encoder/slicetype.c	2007-10-13 21:49:43.905068800 +0400
@@ -313,7 +313,7 @@
         x264_cpu_restore( h->param.cpu );
     }
 
-    if( b_intra_penalty )
+    if( b_intra_penalty && h->sps->i_mb_width > 2 && h->sps->i_mb_height > 2 )
     {
         // arbitrary penalty for I-blocks after B-frames
         int nmb = (h->sps->i_mb_width - 2) * (h->sps->i_mb_height - 2);
@@ -352,7 +352,11 @@
     if( res )
     {
         int imb = frame->i_intra_mbs[pdist];
-        int pmb = (h->sps->i_mb_width - 2) * (h->sps->i_mb_height - 2) - imb;
+        int pmb;
+        if( h->sps->i_mb_width > 2 && h->sps->i_mb_height > 2 )
+            pmb = (h->sps->i_mb_width - 2) * (h->sps->i_mb_height - 2) - imb;
+        else
+            pmb = -imb;
         x264_log( h, X264_LOG_DEBUG, "scene cut at %d Icost:%d Pcost:%d ratio:%.4f bias:%.4f gop:%d (imb:%d pmb:%d)\n",
                   frame->i_frame,
                   icost, pcost, 1. - (double)pcost / icost,
@@ -368,10 +372,15 @@
     int num_frames;
     int keyint_limit;
     int j;
-    int i_mb_count = (h->sps->i_mb_width - 2) * (h->sps->i_mb_height - 2);
+    int i_mb_count;
     int cost1p0, cost2p0, cost1b1, cost2p1;
     int idr_frame_type;
 
+    if( h->sps->i_mb_width > 2 && h->sps->i_mb_height > 2 )
+        i_mb_count = (h->sps->i_mb_width - 2) * (h->sps->i_mb_height - 2);
+    else
+        i_mb_count = 0;
+
     assert( h->frames.b_have_lowres );
 
     if( !h->frames.last_nonb )
@@ -421,9 +430,14 @@
     {
         int pthresh = X264_MAX(INTER_THRESH - P_SENS_BIAS * (j-1), INTER_THRESH/10);
         int pcost = x264_slicetype_frame_cost( h, &a, frames, 0, j+1, j+1, 1 );
-//      fprintf( stderr, "frm%d+%d: %d <=> %d, I:%d/%d \n",
-//               frames[0]->i_frame, j-1, pthresh, pcost/i_mb_count,
-//               frames[j+1]->i_intra_mbs[j+1], i_mb_count );
+//      if( i_mb_count )
+//          fprintf( stderr, "frm%d+%d: %d <=> %d, I:%d/%d \n",
+//                   frames[0]->i_frame, j-1, pthresh, pcost/i_mb_count,
+//                   frames[j+1]->i_intra_mbs[j+1], i_mb_count );
+//      else
+//          fprintf( stderr, "frm%d+%d: %d <=> %d, I:%d/%d \n",
+//                   frames[0]->i_frame, j-1, pthresh, pcost,
+//                   frames[j+1]->i_intra_mbs[j+1], i_mb_count );
         if( pcost > pthresh*i_mb_count || frames[j+1]->i_intra_mbs[j+1] > i_mb_count/3 )
         {
             frames[j]->i_type = X264_TYPE_P;